/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.80 Revision 1.100
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.80 2008/04/03 14:58:59 genstef Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.100 2011/04/24 18:55:20 ulm Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way
6# to provide the functionality required and initial functions
7# required to install external modules against a kernel source
8# tree.
9#
10# Author(s): John Mylchreest <johnm@gentoo.org>, 5# Author(s): John Mylchreest <johnm@gentoo.org>,
11# Stefan Schweizer <genstef@gentoo.org> 6# Stefan Schweizer <genstef@gentoo.org>
12# Maintainer: kernel-misc@gentoo.org 7# Maintainer: kernel-misc@gentoo.org
13# 8#
14# Please direct your bugs to the current eclass maintainer :) 9# Please direct your bugs to the current eclass maintainer :)
15 10
11# @ECLASS: linux-mod.eclass
12# @MAINTAINER:
13# kernel-misc@gentoo.org
14# @BLURB: It provides the functionality required to install external modules against a kernel source tree.
15# @DESCRIPTION:
16# This eclass is used to interface with linux-info.eclass in such a way
17# to provide the functionality and initial functions
18# required to install external modules against a kernel source
19# tree.
20
16# A Couple of env vars are available to effect usage of this eclass 21# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 22# These are as follows:
18# 23
19# Env Var Option Default Description 24# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 25# @DESCRIPTION:
21# the target kernel sources. 26# A string containing the directory of the target kernel sources. The default value is
22# ECONF_PARAMS <string> The parameters to pass to econf. 27# "/usr/src/linux"
28
29# @ECLASS-VARIABLE: ECONF_PARAMS
30# @DESCRIPTION:
31# It's a string containing the parameters to pass to econf.
23# If this is not set, then econf 32# If this is not set, then econf isn't run.
24# isn't run.
25# BUILD_PARAMS <string> The parameters to pass to emake.
26# BUILD_TARGETS <string> clean modules The build targets to pass to
27# make.
28# MODULE_NAMES <string> This is the modules which are
29# to be built automatically using
30# the default pkg_compile/install.
31# They are explained properly
32# below. It will only make
33# BUILD_TARGETS once in any
34# directory.
35 33
36# MODULE_NAMES - Detailed Overview 34# @ECLASS-VARIABLE: BUILD_PARAMS
35# @DESCRIPTION:
36# It's a string with the parameters to pass to emake.
37
38# @ECLASS-VARIABLE: BUILD_TARGETS
39# @DESCRIPTION:
40# It's a string with the build targets to pass to make. The default value is "clean modules"
41
42# @ECLASS-VARIABLE: MODULE_NAMES
43# @DESCRIPTION:
44# It's a string containing the modules to be built automatically using the default
45# src_compile/src_install. It will only make ${BUILD_TARGETS} once in any directory.
37# 46#
38# The structure of each MODULE_NAMES entry is as follows: 47# The structure of each MODULE_NAMES entry is as follows:
48#
39# modulename(libdir:srcdir:objdir) 49# modulename(libdir:srcdir:objdir)
50#
51# where:
52#
53# modulename = name of the module file excluding the .ko
54# libdir = place in system modules directory where module is installed (by default it's misc)
55# srcdir = place for ebuild to cd to before running make (by default it's ${S})
56# objdir = place the .ko and objects are located after make runs (by default it's set to srcdir)
57#
58# To get an idea of how these variables are used, here's a few lines
59# of code from around line 540 in this eclass:
60#
61# einfo "Installing ${modulename} module"
62# cd ${objdir} || die "${objdir} does not exist"
63# insinto /lib/modules/${KV_FULL}/${libdir}
64# doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
65#
40# for example: 66# For example:
41# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 67# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
42# 68#
43# what this would do is 69# what this would do is
70#
44# cd ${S}/pci 71# cd "${S}"/pci
45# make ${BUILD_PARAMS} ${BUILD_TARGETS} 72# make ${BUILD_PARAMS} ${BUILD_TARGETS}
46# cd ${S} 73# cd "${S}"
47# insinto /lib/modules/${KV_FULL}/pci 74# insinto /lib/modules/${KV_FULL}/pci
48# doins module_pci.${KV_OBJ} 75# doins module_pci.${KV_OBJ}
49# 76#
50# cd ${S}/usb 77# cd "${S}"/usb
51# make ${BUILD_PARAMS} ${BUILD_TARGETS} 78# make ${BUILD_PARAMS} ${BUILD_TARGETS}
52# cd ${S} 79# cd "${S}"
53# insinto /lib/modules/${KV_FULL}/usb 80# insinto /lib/modules/${KV_FULL}/usb
54# doins module_usb.${KV_OBJ} 81# doins module_usb.${KV_OBJ}
55#
56# if the srcdir isnt specified, it assumes ${S}
57# if the libdir isnt specified, it assumes misc.
58# if the objdir isnt specified, it assumes srcdir
59 82
60# There is also support for automated modprobe.d/modules.d(2.4) file generation. 83# There is also support for automated modprobe.d/modules.d(2.4) file generation.
61# This can be explicitly enabled by setting any of the following variables. 84# This can be explicitly enabled by setting any of the following variables.
85
86# @ECLASS-VARIABLE: MODULESD_<modulename>_ENABLED
87# @DESCRIPTION:
88# This is used to disable the modprobe.d/modules.d file generation otherwise the file will be
89# always generated (unless no MODULESD_<modulename>_* variable is provided). Set to "no" to disable
90# the generation of the file and the installation of the documentation.
91
92# @ECLASS-VARIABLE: MODULESD_<modulename>_EXAMPLES
93# @DESCRIPTION:
94# This is a bash array containing a list of examples which should
95# be used. If you want us to try and take a guess set this to "guess".
62# 96#
97# For each array_component it's added an options line in the modprobe.d/modules.d file
63# 98#
64# MODULESD_${modulename}_ENABLED This enables the modules.d file 99# options array_component
65# generation even if we dont 100#
66# specify any additional info. 101# where array_component is "<modulename> options" (see modprobe.conf(5))
67# MODULESD_${modulename}_EXAMPLES This is a bash array containing 102
68# a list of examples which should 103# @ECLASS-VARIABLE: MODULESD_<modulename>_ALIASES
69# be used. If you want us to try and 104# @DESCRIPTION:
70# take a guess. Set this to "guess" 105# This is a bash array containing a list of associated aliases.
71# MODULESD_${modulename}_ALIASES This is a bash array containing 106#
72# a list of associated aliases. 107# For each array_component it's added an alias line in the modprobe.d/modules.d file
73# MODULESD_${modulename}_ADDITIONS This is a bash array containing 108#
74# A list of additional things to 109# alias array_component
75# add to the bottom of the file. 110#
76# This can be absolutely anything. 111# where array_component is "wildcard <modulename>" (see modprobe.conf(5))
112
113# @ECLASS-VARIABLE: MODULESD_<modulename>_ADDITIONS
114# @DESCRIPTION:
115# This is a bash array containing a list of additional things to
116# add to the bottom of the file. This can be absolutely anything.
77# Each entry is a new line. 117# Each entry is a new line.
78# MODULES_${modulename}_DOCS This is a string list which contains 118
79# the full path to any associated 119# @ECLASS-VARIABLE: MODULESD_<modulename>_DOCS
80# documents for $modulename 120# @DESCRIPTION:
121# This is a string list which contains the full path to any associated
122# documents for <modulename>. These files are installed in the live tree.
123
124# @ECLASS-VARIABLE: KV_OBJ
125# @DESCRIPTION:
126# It's a read-only variable. It contains the extension of the kernel modules.
81 127
82# The order of these is important as both of linux-info and eutils contain 128# The order of these is important as both of linux-info and eutils contain
83# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils 129# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
84# are deprecated in favor of the ones in linux-info. 130# are deprecated in favor of the ones in linux-info.
85# See http://bugs.gentoo.org/show_bug.cgi?id=127506 131# See http://bugs.gentoo.org/show_bug.cgi?id=127506
88EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm 134EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
89 135
90IUSE="kernel_linux" 136IUSE="kernel_linux"
91SLOT="0" 137SLOT="0"
92DESCRIPTION="Based on the $ECLASS eclass" 138DESCRIPTION="Based on the $ECLASS eclass"
93RDEPEND="kernel_linux? ( virtual/modutils )" 139RDEPEND="kernel_linux? ( sys-apps/module-init-tools )"
94DEPEND="${RDEPEND} 140DEPEND="${RDEPEND}
95 sys-apps/sed" 141 sys-apps/sed
142 kernel_linux? ( virtual/linux-sources )"
96 143
97# eclass utilities 144# eclass utilities
98# ---------------------------------- 145# ----------------------------------
99 146
100check_vermagic() { 147check_vermagic() {
101 debug-print-function ${FUNCNAME} $* 148 debug-print-function ${FUNCNAME} $*
102 149
103 local curr_gcc_ver=$(gcc -dumpversion) 150 local curr_gcc_ver=$(gcc -dumpversion)
104 local tmpfile old_chost old_gcc_ver result=0 151 local tmpfile old_chost old_gcc_ver result=0
105 152
106 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 153 tmpfile=`find "${KV_DIR}/" -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
107 tmpfile=${tmpfile//*usr/lib} 154 tmpfile=${tmpfile//*usr/lib}
108 tmpfile=${tmpfile//\/include*} 155 tmpfile=${tmpfile//\/include*}
109 old_chost=${tmpfile//*gcc\/} 156 old_chost=${tmpfile//*gcc\/}
110 old_chost=${old_chost//\/*} 157 old_chost=${old_chost//\/*}
111 old_gcc_ver=${tmpfile//*\/} 158 old_gcc_ver=${tmpfile//*\/}
134 ewarn "to match the kernel, or recompile the kernel first." 181 ewarn "to match the kernel, or recompile the kernel first."
135 die "GCC Version Mismatch." 182 die "GCC Version Mismatch."
136 fi 183 fi
137} 184}
138 185
186# @FUNCTION: use_m
187# @RETURN: true or false
188# @DESCRIPTION:
189# It checks if the kernel version is greater than 2.6.5.
139use_m() { 190use_m() {
140 debug-print-function ${FUNCNAME} $* 191 debug-print-function ${FUNCNAME} $*
141 192
142 # if we haven't determined the version yet, we need too. 193 # if we haven't determined the version yet, we need too.
143 get_version; 194 get_version;
146 # M= instead of SUBDIRS= 197 # M= instead of SUBDIRS=
147 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 198 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
148 return 0 || return 1 199 return 0 || return 1
149} 200}
150 201
202# @FUNCTION: convert_to_m
203# @USAGE: /path/to/the/file
204# @DESCRIPTION:
205# It converts a file (e.g. a makefile) to use M= instead of SUBDIRS=
151convert_to_m() { 206convert_to_m() {
152 debug-print-function ${FUNCNAME} $* 207 debug-print-function ${FUNCNAME} $*
153 208
154 if use_m 209 if use_m
155 then 210 then
156 [ ! -f "${1}" ] && \ 211 [ ! -f "${1}" ] && \
157 die "convert_to_m() requires a filename as an argument" 212 die "convert_to_m() requires a filename as an argument"
158 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 213 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
159 sed -i 's:SUBDIRS=:M=:g' ${1} 214 sed -i 's:SUBDIRS=:M=:g' "${1}"
160 eend $? 215 eend $?
161 fi 216 fi
162} 217}
163 218
219# internal function
220#
221# FUNCTION: update_depmod
222# DESCRIPTION:
223# It updates the modules.dep file for the current kernel.
164update_depmod() { 224update_depmod() {
165 debug-print-function ${FUNCNAME} $* 225 debug-print-function ${FUNCNAME} $*
166 226
167 # if we haven't determined the version yet, we need too. 227 # if we haven't determined the version yet, we need too.
168 get_version; 228 get_version;
169 229
170 ebegin "Updating module dependencies for ${KV_FULL}" 230 ebegin "Updating module dependencies for ${KV_FULL}"
171 if [ -r ${KV_OUT_DIR}/System.map ] 231 if [ -r "${KV_OUT_DIR}"/System.map ]
172 then 232 then
173 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL} 233 depmod -ae -F "${KV_OUT_DIR}"/System.map -b "${ROOT}" -r ${KV_FULL}
174 eend $? 234 eend $?
175 else 235 else
176 ewarn 236 ewarn
177 ewarn "${KV_OUT_DIR}/System.map not found." 237 ewarn "${KV_OUT_DIR}/System.map not found."
178 ewarn "You must manually update the kernel module dependencies using depmod." 238 ewarn "You must manually update the kernel module dependencies using depmod."
179 eend 1 239 eend 1
180 ewarn 240 ewarn
181 fi 241 fi
182} 242}
183 243
244# internal function
245#
246# FUNCTION: update_modules
247# DESCRIPTION:
248# It calls the update-modules utility.
184update_modules() { 249update_modules() {
185 debug-print-function ${FUNCNAME} $* 250 debug-print-function ${FUNCNAME} $*
186 251
187 if [ -x /sbin/update-modules ] && \ 252 if [ -x /sbin/update-modules ] && \
188 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 253 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
189 ebegin "Updating modules.conf" 254 ebegin "Updating modules.conf"
190 /sbin/update-modules 255 /sbin/update-modules
191 eend $? 256 eend $?
192 elif [ -x /sbin/update-modules ] && \ 257 elif [ -x /sbin/update-modules ] && \
193 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 258 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
194 ebegin "Updating modules.conf" 259 ebegin "Updating modules.conf"
195 /sbin/update-modules 260 /sbin/update-modules
196 eend $? 261 eend $?
197 fi 262 fi
198} 263}
199 264
265# internal function
266#
267# FUNCTION: move_old_moduledb
268# DESCRIPTION:
269# It updates the location of the database used by the module-rebuild utility.
200move_old_moduledb() { 270move_old_moduledb() {
201 debug-print-function ${FUNCNAME} $* 271 debug-print-function ${FUNCNAME} $*
202 272
203 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 273 local OLDDIR="${ROOT}"/usr/share/module-rebuild/
204 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 274 local NEWDIR="${ROOT}"/var/lib/module-rebuild/
205 275
206 if [[ -f ${OLDDIR}/moduledb ]]; then 276 if [[ -f "${OLDDIR}"/moduledb ]]; then
207 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 277 [[ ! -d "${NEWDIR}" ]] && mkdir -p "${NEWDIR}"
208 [[ ! -f ${NEWDIR}/moduledb ]] && \ 278 [[ ! -f "${NEWDIR}"/moduledb ]] && \
209 mv ${OLDDIR}/moduledb ${NEWDIR}/moduledb 279 mv "${OLDDIR}"/moduledb "${NEWDIR}"/moduledb
210 rm -f ${OLDDIR}/* 280 rm -f "${OLDDIR}"/*
211 rmdir ${OLDDIR} 281 rmdir "${OLDDIR}"
212 fi 282 fi
213} 283}
214 284
285# internal function
286#
287# FUNCTION: update_moduledb
288# DESCRIPTION:
289# It adds the package to the /var/lib/module-rebuild/moduledb database used by the module-rebuild utility.
215update_moduledb() { 290update_moduledb() {
216 debug-print-function ${FUNCNAME} $* 291 debug-print-function ${FUNCNAME} $*
217 292
218 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 293 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
219 move_old_moduledb 294 move_old_moduledb
220 295
221 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 296 if [[ ! -f "${MODULEDB_DIR}"/moduledb ]]; then
222 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 297 [[ ! -d "${MODULEDB_DIR}" ]] && mkdir -p "${MODULEDB_DIR}"
223 touch ${MODULEDB_DIR}/moduledb 298 touch "${MODULEDB_DIR}"/moduledb
224 fi 299 fi
225 300
226 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then 301 if ! grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
227 einfo "Adding module to moduledb." 302 einfo "Adding module to moduledb."
228 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 303 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> "${MODULEDB_DIR}"/moduledb
229 fi 304 fi
230} 305}
231 306
307# internal function
308#
309# FUNCTION: remove_moduledb
310# DESCRIPTION:
311# It removes the package from the /var/lib/module-rebuild/moduledb database used by
312# the module-rebuild utility.
232remove_moduledb() { 313remove_moduledb() {
233 debug-print-function ${FUNCNAME} $* 314 debug-print-function ${FUNCNAME} $*
234 315
235 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 316 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
236 move_old_moduledb 317 move_old_moduledb
237 318
238 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then 319 if grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
239 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 320 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
240 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb 321 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" "${MODULEDB_DIR}"/moduledb
241 fi 322 fi
242} 323}
243 324
325# @FUNCTION: set_kvobj
326# @DESCRIPTION:
327# It sets the KV_OBJ variable.
244set_kvobj() { 328set_kvobj() {
245 debug-print-function ${FUNCNAME} $* 329 debug-print-function ${FUNCNAME} $*
246 330
247 if kernel_is 2 6 331 if kernel_is 2 6
248 then 332 then
255 # einfo "Using KV_OBJ=${KV_OBJ}" 339 # einfo "Using KV_OBJ=${KV_OBJ}"
256} 340}
257 341
258get-KERNEL_CC() { 342get-KERNEL_CC() {
259 debug-print-function ${FUNCNAME} $* 343 debug-print-function ${FUNCNAME} $*
344
345 if [[ -n ${KERNEL_CC} ]] ; then
346 echo "${KERNEL_CC}"
347 return
348 fi
260 349
261 local kernel_cc 350 local kernel_cc
262 if [ -n "${KERNEL_ABI}" ]; then 351 if [ -n "${KERNEL_ABI}" ]; then
263 # In future, an arch might want to define CC_$ABI 352 # In future, an arch might want to define CC_$ABI
264 #kernel_cc="$(get_abi_CC)" 353 #kernel_cc="$(get_abi_CC)"
268 kernel_cc=$(tc-getCC) 357 kernel_cc=$(tc-getCC)
269 fi 358 fi
270 echo "${kernel_cc}" 359 echo "${kernel_cc}"
271} 360}
272 361
362# internal function
363#
364# FUNCTION:
365# USAGE: /path/to/the/modulename_without_extension
366# RETURN: A file in /etc/modules.d/ (kernel < 2.6) or /etc/modprobe.d/ (kernel >= 2.6)
367# DESCRIPTION:
368# This function will generate and install the neccessary modprobe.d/modules.d file from the
369# information contained in the modules exported parms.
370# (see the variables MODULESD_<modulename>_ENABLED, MODULESD_<modulename>_EXAMPLES,
371# MODULESD_<modulename>_ALIASES, MODULESD_<modulename>_ADDITION and MODULESD_<modulename>_DOCS).
372#
373# At the end the documentation specified with MODULESD_<modulename>_DOCS is installed.
273generate_modulesd() { 374generate_modulesd() {
274 debug-print-function ${FUNCNAME} $* 375 debug-print-function ${FUNCNAME} $*
275
276 # This function will generate the neccessary modules.d file from the
277 # information contained in the modules exported parms
278 376
279 local currm_path currm currm_t t myIFS myVAR 377 local currm_path currm currm_t t myIFS myVAR
280 local module_docs module_enabled module_aliases \ 378 local module_docs module_enabled module_aliases \
281 module_additions module_examples module_modinfo module_opts 379 module_additions module_examples module_modinfo module_opts
282 380
316 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})" 414 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})"
317 module_config="${T}/modulesd-${currm}" 415 module_config="${T}/modulesd-${currm}"
318 416
319 ebegin "Preparing file for modules.d" 417 ebegin "Preparing file for modules.d"
320 #----------------------------------------------------------------------- 418 #-----------------------------------------------------------------------
321 echo "# modules.d configuration file for ${currm}" >> ${module_config} 419 echo "# modules.d configuration file for ${currm}" >> "${module_config}"
322 #----------------------------------------------------------------------- 420 #-----------------------------------------------------------------------
323 [[ -n ${module_docs} ]] && \ 421 [[ -n ${module_docs} ]] && \
324 echo "# For more information please read:" >> ${module_config} 422 echo "# For more information please read:" >> "${module_config}"
325 for t in ${module_docs} 423 for t in ${module_docs}
326 do 424 do
327 echo "# ${t//*\/}" >> ${module_config} 425 echo "# ${t//*\/}" >> "${module_config}"
328 done 426 done
329 echo >> ${module_config} 427 echo >> "${module_config}"
330 428
331 #----------------------------------------------------------------------- 429 #-----------------------------------------------------------------------
332 if [[ ${module_aliases} -gt 0 ]] 430 if [[ ${module_aliases} -gt 0 ]]
333 then 431 then
334 echo "# Internal Aliases - Do not edit" >> ${module_config} 432 echo "# Internal Aliases - Do not edit" >> "${module_config}"
335 echo "# ------------------------------" >> ${module_config} 433 echo "# ------------------------------" >> "${module_config}"
336 434
337 for((t=0; t<${module_aliases}; t++)) 435 for((t=0; t<${module_aliases}; t++))
338 do 436 do
339 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \ 437 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \
340 >> ${module_config} 438 >> "${module_config}"
341 done 439 done
342 echo '' >> ${module_config} 440 echo '' >> "${module_config}"
343 fi 441 fi
344 442
345 #----------------------------------------------------------------------- 443 #-----------------------------------------------------------------------
346 if [[ -n ${module_modinfo} ]] 444 if [[ -n ${module_modinfo} ]]
347 then 445 then
348 echo >> ${module_config} 446 echo >> "${module_config}"
349 echo "# Configurable module parameters" >> ${module_config} 447 echo "# Configurable module parameters" >> "${module_config}"
350 echo "# ------------------------------" >> ${module_config} 448 echo "# ------------------------------" >> "${module_config}"
351 myIFS="${IFS}" 449 myIFS="${IFS}"
352 IFS="$(echo -en "\n\b")" 450 IFS="$(echo -en "\n\b")"
353 451
354 for t in ${module_modinfo} 452 for t in ${module_modinfo}
355 do 453 do
356 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")" 454 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")"
357 if [[ -n ${myVAR} ]] 455 if [[ -n ${myVAR} ]]
358 then 456 then
359 module_opts="${module_opts} ${t%%:*}:${myVAR}" 457 module_opts="${module_opts} ${t%%:*}:${myVAR}"
360 fi 458 fi
361 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config} 459 echo -e "# ${t%%:*}:\t${t#*:}" >> "${module_config}"
362 done 460 done
363 IFS="${myIFS}" 461 IFS="${myIFS}"
364 echo '' >> ${module_config} 462 echo '' >> "${module_config}"
365 fi 463 fi
366 464
367 #----------------------------------------------------------------------- 465 #-----------------------------------------------------------------------
368 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]] 466 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]]
369 then 467 then
370 # So lets do some guesswork eh? 468 # So lets do some guesswork eh?
371 if [[ -n ${module_opts} ]] 469 if [[ -n ${module_opts} ]]
372 then 470 then
373 echo "# For Example..." >> ${module_config} 471 echo "# For Example..." >> "${module_config}"
374 echo "# --------------" >> ${module_config} 472 echo "# --------------" >> "${module_config}"
375 for t in ${module_opts} 473 for t in ${module_opts}
376 do 474 do
377 echo "# options ${currm} ${t//:*}=${t//*:}" >> ${module_config} 475 echo "# options ${currm} ${t//:*}=${t//*:}" >> "${module_config}"
378 done 476 done
379 echo '' >> ${module_config} 477 echo '' >> "${module_config}"
380 fi 478 fi
381 elif [[ ${module_examples} -gt 0 ]] 479 elif [[ ${module_examples} -gt 0 ]]
382 then 480 then
383 echo "# For Example..." >> ${module_config} 481 echo "# For Example..." >> "${module_config}"
384 echo "# --------------" >> ${module_config} 482 echo "# --------------" >> "${module_config}"
385 for((t=0; t<${module_examples}; t++)) 483 for((t=0; t<${module_examples}; t++))
386 do 484 do
387 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \ 485 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \
388 >> ${module_config} 486 >> "${module_config}"
389 done 487 done
390 echo '' >> ${module_config} 488 echo '' >> "${module_config}"
391 fi 489 fi
392 490
393 #----------------------------------------------------------------------- 491 #-----------------------------------------------------------------------
394 if [[ ${module_additions} -gt 0 ]] 492 if [[ ${module_additions} -gt 0 ]]
395 then 493 then
396 for((t=0; t<${module_additions}; t++)) 494 for((t=0; t<${module_additions}; t++))
397 do 495 do
398 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \ 496 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \
399 >> ${module_config} 497 >> "${module_config}"
400 done 498 done
401 echo '' >> ${module_config} 499 echo '' >> "${module_config}"
402 fi 500 fi
403 501
404 #----------------------------------------------------------------------- 502 #-----------------------------------------------------------------------
405 503
406 # then we install it 504 # then we install it
407 if kernel_is ge 2 6 505 if kernel_is ge 2 6; then
408 insinto /etc/modprobe.d 506 insinto /etc/modprobe.d
409 else 507 else
410 insinto /etc/modules.d 508 insinto /etc/modules.d
411 fi 509 fi
412 newins ${module_config} ${currm_path//*\/} 510 newins "${module_config}" "${currm_path//*\/}.conf"
413 511
414 # and install any documentation we might have. 512 # and install any documentation we might have.
415 [[ -n ${module_docs} ]] && dodoc ${module_docs} 513 [[ -n ${module_docs} ]] && dodoc ${module_docs}
416 done 514 done
417 eend 0 515 eend 0
418 return 0 516 return 0
419} 517}
420 518
519# internal function
520#
521# FUNCTION: find_module_params
522# USAGE: A string "NAME(LIBDIR:SRCDIR:OBJDIR)"
523# RETURN: The string "modulename:NAME libdir:LIBDIR srcdir:SRCDIR objdir:OBJDIR"
524# DESCRIPTION:
525# Analyze the specification NAME(LIBDIR:SRCDIR:OBJDIR) of one module as described in MODULE_NAMES.
421find_module_params() { 526find_module_params() {
422 debug-print-function ${FUNCNAME} $* 527 debug-print-function ${FUNCNAME} $*
423 528
424 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 529 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
425 local i=0 y=0 z=0 530 local i=0 y=0 z=0
461} 566}
462 567
463# default ebuild functions 568# default ebuild functions
464# -------------------------------- 569# --------------------------------
465 570
571# @FUNCTION: linux-mod_pkg_setup
572# @DESCRIPTION:
573# It checks the CONFIG_CHECK options (see linux-info.eclass(5)), verifies that the kernel is
574# configured, verifies that the sources are prepared, verifies that the modules support is builtin
575# in the kernel and sets the object extension KV_OBJ.
466linux-mod_pkg_setup() { 576linux-mod_pkg_setup() {
467 debug-print-function ${FUNCNAME} $* 577 debug-print-function ${FUNCNAME} $*
578
579 # If we are installing a binpkg, take a different path.
580 if [[ $EMERGE_FROM == binary ]]; then
581 linux-mod_pkg_setup_binary
582 return
583 fi
468 584
469 linux-info_pkg_setup; 585 linux-info_pkg_setup;
470 require_configured_kernel 586 require_configured_kernel
471 check_kernel_built; 587 check_kernel_built;
472 strip_modulenames; 588 strip_modulenames;
476 # who intentionally use different kernel and userland compilers can be 592 # who intentionally use different kernel and userland compilers can be
477 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005 593 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
478 #check_vermagic; 594 #check_vermagic;
479} 595}
480 596
597# @FUNCTION: linux-mod_pkg_setup_binary
598# @DESCRIPTION:
599# Perform all kernel option checks non-fatally, as the .config and
600# /proc/config.gz might not be present. Do not do anything that requires kernel
601# sources.
602linux-mod_pkg_setup_binary() {
603 debug-print-function ${FUNCNAME} $*
604 local new_CONFIG_CHECK
605 # ~ needs always to be quoted, else bash expands it.
606 for config in $CONFIG_CHECK ; do
607 optional='~'
608 [[ ${config:0:1} == "~" ]] && optional=''
609 new_CONFIG_CHECK="${new_CONFIG_CHECK} ${optional}${config}"
610 done
611 export CONFIG_CHECK="${new_CONFIG_CHECK}"
612 linux-info_pkg_setup;
613}
614
481strip_modulenames() { 615strip_modulenames() {
482 debug-print-function ${FUNCNAME} $* 616 debug-print-function ${FUNCNAME} $*
483 617
484 local i 618 local i
485 for i in ${MODULE_IGNORE}; do 619 for i in ${MODULE_IGNORE}; do
486 MODULE_NAMES=${MODULE_NAMES//${i}(*} 620 MODULE_NAMES=${MODULE_NAMES//${i}(*}
487 done 621 done
488} 622}
489 623
624# @FUNCTION: linux-mod_src_compile
625# @DESCRIPTION:
626# It compiles all the modules specified in MODULE_NAMES. For each module the econf command is
627# executed only if ECONF_PARAMS is defined, the name of the target is specified by BUILD_TARGETS
628# while the options are in BUILD_PARAMS (all the modules share these variables). The compilation
629# happens inside ${srcdir}.
630#
631# Look at the description of these variables for more details.
490linux-mod_src_compile() { 632linux-mod_src_compile() {
491 debug-print-function ${FUNCNAME} $* 633 debug-print-function ${FUNCNAME} $*
492 634
493 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}" 635 local modulename libdir srcdir objdir i n myABI="${ABI}"
494 ARCH="$(tc-arch-kernel)" 636 set_arch_to_kernel
495 ABI="${KERNEL_ABI}" 637 ABI="${KERNEL_ABI}"
496 638
497 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 639 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
498 strip_modulenames; 640 strip_modulenames;
499 cd "${S}" 641 cd "${S}"
642 touch Module.symvers
500 for i in ${MODULE_NAMES} 643 for i in ${MODULE_NAMES}
501 do 644 do
502 unset libdir srcdir objdir 645 unset libdir srcdir objdir
503 for n in $(find_module_params ${i}) 646 for n in $(find_module_params ${i})
504 do 647 do
508 srcdir=${srcdir:-${S}} 651 srcdir=${srcdir:-${S}}
509 objdir=${objdir:-${srcdir}} 652 objdir=${objdir:-${srcdir}}
510 653
511 if [ ! -f "${srcdir}/.built" ]; 654 if [ ! -f "${srcdir}/.built" ];
512 then 655 then
513 cd ${srcdir} 656 cd "${srcdir}"
657 ln -s "${S}"/Module.symvers Module.symvers
514 einfo "Preparing ${modulename} module" 658 einfo "Preparing ${modulename} module"
515 if [[ -n ${ECONF_PARAMS} ]] 659 if [[ -n ${ECONF_PARAMS} ]]
516 then 660 then
517 econf ${ECONF_PARAMS} || \ 661 econf ${ECONF_PARAMS} || \
518 die "Unable to run econf ${ECONF_PARAMS}" 662 die "Unable to run econf ${ECONF_PARAMS}"
519 fi 663 fi
520 664
521 # This looks messy, but it is needed to handle multiple variables 665 # This looks messy, but it is needed to handle multiple variables
522 # being passed in the BUILD_* stuff where the variables also have 666 # being passed in the BUILD_* stuff where the variables also have
523 # spaces that must be preserved. If don't do this, then the stuff 667 # spaces that must be preserved. If don't do this, then the stuff
524 # inside the variables gets used as targets for Make, which then 668 # inside the variables gets used as targets for Make, which then
525 # fails. 669 # fails.
526 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \ 670 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
527 CC=\"$(get-KERNEL_CC)\" \ 671 CROSS_COMPILE=${CHOST}- \
528 LDFLAGS=\"$(get_abi_LDFLAGS)\" \ 672 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
529 ${BUILD_FIXES} \ 673 ${BUILD_FIXES} \
530 ${BUILD_PARAMS} \ 674 ${BUILD_PARAMS} \
531 ${BUILD_TARGETS} " \ 675 ${BUILD_TARGETS} " \
532 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}" 676 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CROSS_COMPILE=${CHOST}- LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
677 cd "${OLDPWD}"
533 touch ${srcdir}/.built 678 touch "${srcdir}"/.built
534 cd ${OLDPWD}
535 fi 679 fi
536 done 680 done
537 681
538 ARCH="${myARCH}" 682 set_arch_to_portage
539 ABI="${myABI}" 683 ABI="${myABI}"
540} 684}
541 685
686# @FUNCTION: linux-mod_src_install
687# @DESCRIPTION:
688# It install the modules specified in MODULES_NAME. The modules should be inside the ${objdir}
689# directory and they are installed inside /lib/modules/${KV_FULL}/${libdir}.
690#
691# The modprobe.d/modules.d configuration file is automatically generated if the
692# MODULESD_<modulename>_* variables are defined. The only way to stop this process is by
693# setting MODULESD_<modulename>_ENABLED=no. At the end the documentation specified via
694# MODULESD_<modulename>_DOCS is also installed.
695#
696# Look at the description of these variables for more details.
542linux-mod_src_install() { 697linux-mod_src_install() {
543 debug-print-function ${FUNCNAME} $* 698 debug-print-function ${FUNCNAME} $*
544 699
545 local modulename libdir srcdir objdir i n 700 local modulename libdir srcdir objdir i n
546 701
555 libdir=${libdir:-misc} 710 libdir=${libdir:-misc}
556 srcdir=${srcdir:-${S}} 711 srcdir=${srcdir:-${S}}
557 objdir=${objdir:-${srcdir}} 712 objdir=${objdir:-${srcdir}}
558 713
559 einfo "Installing ${modulename} module" 714 einfo "Installing ${modulename} module"
560 cd ${objdir} || die "${objdir} does not exist" 715 cd "${objdir}" || die "${objdir} does not exist"
561 insinto /lib/modules/${KV_FULL}/${libdir} 716 insinto /lib/modules/${KV_FULL}/${libdir}
562 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed" 717 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
563 cd ${OLDPWD} 718 cd "${OLDPWD}"
564 719
565 generate_modulesd ${objdir}/${modulename} 720 generate_modulesd "${objdir}/${modulename}"
566 done 721 done
567} 722}
568 723
724# @FUNCTION: linux-mod_pkg_preinst
725# @DESCRIPTION:
726# It checks what to do after having merged the package.
569linux-mod_pkg_preinst() { 727linux-mod_pkg_preinst() {
570 debug-print-function ${FUNCNAME} $* 728 debug-print-function ${FUNCNAME} $*
571 729
572 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false 730 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
573 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false 731 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
574 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false 732 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
575} 733}
576 734
735# @FUNCTION: linux-mod_pkg_postinst
736# @DESCRIPTION:
737# It executes /sbin/depmod and adds the package to the /var/lib/module-rebuild/moduledb
738# database (if ${D}/lib/modules is created) and it runs /sbin/update-modules
739# (if ${D}/etc/modules.d is created).
577linux-mod_pkg_postinst() { 740linux-mod_pkg_postinst() {
578 debug-print-function ${FUNCNAME} $* 741 debug-print-function ${FUNCNAME} $*
579 742
580 ${UPDATE_DEPMOD} && update_depmod; 743 ${UPDATE_DEPMOD} && update_depmod;
581 ${UPDATE_MODULES} && update_modules; 744 ${UPDATE_MODULES} && update_modules;
582 ${UPDATE_MODULEDB} && update_moduledb; 745 ${UPDATE_MODULEDB} && update_moduledb;
583} 746}
584 747
748# @FUNCTION: linux-mod_pkg_postrm
749# @DESCRIPTION:
750# It removes the package from the /var/lib/module-rebuild/moduledb database but it doens't
751# call /sbin/depmod and /sbin/update-modules because the modules are still installed.
585linux-mod_pkg_postrm() { 752linux-mod_pkg_postrm() {
586 debug-print-function ${FUNCNAME} $* 753 debug-print-function ${FUNCNAME} $*
587 remove_moduledb; 754 remove_moduledb;
588} 755}

Legend:
Removed from v.1.80  
changed lines
  Added in v.1.100

  ViewVC Help
Powered by ViewVC 1.1.20